/*********************************************************************
 *  SPDX-License-Identifier: MIT                                     *
 *  Copyright (C) 2023 by Helge Kortendieck  alan@kasmithee.de       *
 *                                                                   *
 *  This file is part of qaplay.                                     *
 *********************************************************************/

#ifndef _SONGLIST_H_
#define _SONGLIST_H_

#include <QDialog>
#include <QList>
#include <QListWidget>
#include <QListWidgetItem>
#include <QMessageBox>
//#include <QPoint>
#include <QString>
#include <QWidget>

#include "ui_songlist.h"

#include "m3u.h"
#include "structs.h"

#include <iostream>
using namespace std;

class SongList : public QDialog
{
	Q_OBJECT

public:
	SongList(QDialog* parent = 0);
		~SongList();

private:
	int sliD;
	int sliD2;
	int sliCount;
	int sliCurIdx;
	int sliRet;

	QString slsD;
	QString slsD2;

	QStringList slslD;		// song list - full path/name, 1 entry per line
	QStringList slslSongs;	// song list - full path/name, 1 entry per line
//	SongList slDSl;			// song list struct entity

	Ui::wSongList uiSl;		// song list widget

	QDialog wSl;			// song list widget

//	QPoint qPos;
	
	StrM3u slStrM3uD;			// playlist item struct entity
	QList<StrM3u> slLiItems;	// list with songs in StrM3u items
	QList<StrM3u> slLiItemsD;	// list with songs in StrM3u items

private slots:
	void slDlgApply();			// close dialog - apply changes to playlist
	void slDlgCancel();			// close dialog - no updates to playlist
	void slDlgPop();			// populate list widget with songs
	void slDlgShow(int sliD, const QString& slsD, const QStringList& slslD);	// show song list dialog
	void slSongCurChngd(int sliD);	// current song changed
	void slSongDown();			// move selected song down by 1 position
	void slSongDrop();			// drop selected song from playlist
	void slSongUp();			// move selected song up by 1 position

	signals:
		void sigSlQapSongChngd(int sliD);
		void sigSlQapDelete();
};

#endif
